    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ---------------------------------
    028     * SymbolicXYItemLabelGenerator.java
    029     * ---------------------------------
    030     * (C) Copyright 2001-2005, by Anthony Boulestreau and Contributors.
    031     *
    032     * Original Author:  Anthony Boulestreau;
    033     * Contributor(s):   David Gilbert (for Object Refinery Limited);
    034     *
    035     * $Id: SymbolicXYItemLabelGenerator.java,v 1.5.2.1 2005/10/25 20:49:02 mungady Exp $
    036     *
    037     * Changes
    038     * -------
    039     * 29-Mar-2002 : Version 1, contributed by Anthony Boulestreau (DG);
    040     * 26-Sep-2002 : Fixed errors reported by Checkstyle (DG);
    041     * 23-Mar-2003 : Implemented Serializable (DG);
    042     * 13-Aug-2003 : Implemented Cloneable (DG);
    043     * 17-Nov-2003 : Implemented PublicCloneable (DG);
    044     * 25-Feb-2004 : Renamed XYToolTipGenerator --> XYItemLabelGenerator (DG);
    045     * 19-Jan-2005 : Now accesses primitives only from dataset (DG);
    046     * 20-Apr-2005 : Renamed XYLabelGenerator --> XYItemLabelGenerator (DG);
    047     *
    048     */
    049
    050    package org.jfree.chart.labels;
    051
    052    import java.io.Serializable;
    053
    054    import org.jfree.data.time.RegularTimePeriod;
    055    import org.jfree.data.time.TimeSeriesCollection;
    056    import org.jfree.data.xy.XYDataset;
    057    import org.jfree.data.xy.XisSymbolic;
    058    import org.jfree.data.xy.YisSymbolic;
    059    import org.jfree.util.PublicCloneable;
    060
    061    /**
    062     * A standard item label generator for plots that use data from an
    063     * {@link XYDataset}.
    064     *
    065     * @author Anthony Boulestreau
    066     */
    067    public class SymbolicXYItemLabelGenerator implements XYItemLabelGenerator,
    068                                                         XYToolTipGenerator,
    069                                                         Cloneable,
    070                                                         PublicCloneable,
    071                                                         Serializable {
    072
    073        /** For serialization. */
    074        private static final long serialVersionUID = 3963400354475494395L;
    075
    076        /**
    077         * Generates a tool tip text item for a particular item within a series.
    078         *
    079         * @param data  the dataset.
    080         * @param series  the series number (zero-based index).
    081         * @param item  the item number (zero-based index).
    082         *
    083         * @return The tool tip text (possibly <code>null</code>).
    084         */
    085        public String generateToolTip(XYDataset data, int series, int item) {
    086
    087            String xStr, yStr;
    088            if (data instanceof YisSymbolic) {
    089                yStr = ((YisSymbolic) data).getYSymbolicValue(series, item);
    090            }
    091            else {
    092                double y = data.getYValue(series, item);
    093                yStr = Double.toString(round(y, 2));
    094            }
    095            if (data instanceof XisSymbolic) {
    096                xStr = ((XisSymbolic) data).getXSymbolicValue(series, item);
    097            }
    098            else if (data instanceof TimeSeriesCollection) {
    099                RegularTimePeriod p
    100                    = ((TimeSeriesCollection) data).getSeries(series)
    101                        .getTimePeriod(item);
    102                xStr = p.toString();
    103            }
    104            else {
    105                double x = data.getXValue(series, item);
    106                xStr = Double.toString(round(x, 2));
    107            }
    108            return "X: " + xStr + ", Y: " + yStr;
    109        }
    110
    111        /**
    112         * Generates a label for the specified item. The label is typically a
    113         * formatted version of the data value, but any text can be used.
    114         *
    115         * @param dataset  the dataset (<code>null</code> not permitted).
    116         * @param series  the series index (zero-based).
    117         * @param category  the category index (zero-based).
    118         *
    119         * @return The label (possibly <code>null</code>).
    120         */
    121        public String generateLabel(XYDataset dataset, int series, int category) {
    122            return null;  //TODO: implement this method properly
    123        }
    124
    125        /**
    126        * Round a double value.
    127        *
    128        * @param value  the value.
    129        * @param nb  the exponent.
    130        *
    131        * @return The rounded value.
    132        */
    133        private static double round(double value, int nb) {
    134            if (nb <= 0) {
    135                return Math.floor(value + 0.5d);
    136            }
    137            double p = Math.pow(10, nb);
    138            double tempval = Math.floor(value * p + 0.5d);
    139            return tempval / p;
    140        }
    141
    142        /**
    143         * Returns an independent copy of the generator.
    144         *
    145         * @return A clone.
    146         *
    147         * @throws CloneNotSupportedException if cloning is not supported.
    148         */
    149        public Object clone() throws CloneNotSupportedException {
    150            return super.clone();
    151        }
    152
    153        /**
    154         * Tests if this object is equal to another.
    155         *
    156         * @param obj  the other object.
    157         *
    158         * @return A boolean.
    159         */
    160        public boolean equals(Object obj) {
    161            if (obj == this) {
    162                return true;
    163            }
    164            if (obj instanceof SymbolicXYItemLabelGenerator) {
    165                return true;
    166            }
    167            return false;
    168        }
    169
    170    }